/*************************************************************************************************/
/*       3                                          */
/*  ----------------------------------------------------										 */
/*    															 */
/*  .  																 */
/*    																	 */
/*  ----------------------------------------------------										 */
/*  : .  															 */
/*																								 */
/*  (c) - 2004                                                               */
/*                                                                                               */
/*************************************************************************************************/


#include "Main.h"

HPEN axispen;
HPEN limitpen;
HPEN linepen;

// =============================================================================================
// APPLICATION'S ENTRY POINT
//          .   MainAppWindow  
//    . 
// =============================================================================================

int APIENTRY WinMain (HINSTANCE hInstance,HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;
	WNDCLASSEX wc;
	int i;
	
	//   
	// ---------------------------------------------------------------------------
		data.counter=(int) (data.DELAY/(float)INTERVAL);
		for (i=0;i<CHART_SIZE;i++)
		{
			xpos[i]=ypos[i]=zpos[i]=0;
		}

		xptr=yptr=zptr=0;
		chinc=0;
	// ---------------------------------------------------------------------------
	hInst=hInstance;
	
	wc.style=CS_HREDRAW|CS_VREDRAW;;
	wc.lpfnWndProc=(WNDPROC) WndProc;
	wc.cbWndExtra=0;
	wc.cbClsExtra=0;
	wc.hInstance=hInstance;
	wc.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_APPICON));
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_SCROLLBAR+1);
	wc.lpszMenuName=MAKEINTRESOURCE(IDR_MENU);
	wc.lpszClassName=lpszAppName;
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.hIconSm=(HICON)LoadIcon(hInstance,MAKEINTRESOURCE(IDI_APPICON));
	if (!RegisterClassEx(&wc)) return (FALSE);
	
	MainAppWnd = CreateWindowEx(0,lpszAppName,lpszTitle,WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,
						  900,600,NULL,NULL,hInst,NULL);

	if (!MainAppWnd) return (FALSE);
	ShowWindow(MainAppWnd,nShowCmd);
	UpdateWindow (MainAppWnd);


	while (GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (msg.wParam);
}

// =============================================================================================
// WINDOW CREATION FUNCTIONS
//          .     
//      
// =============================================================================================

HWND MyCreateWindow(HWND hParentWindow,HINSTANCE hInst,char * ClassName,WNDPROC callback, DWORD Style,COLORREF back_color)
{
	WNDCLASSEX wc;
	HWND TempHandle;

	HBRUSH hbrush;
	wc.style=CS_HREDRAW|CS_VREDRAW;;
	wc.lpfnWndProc=callback;
	wc.cbWndExtra=0;
	wc.cbClsExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);;
	hbrush=CreateSolidBrush(back_color);
	wc.hbrBackground=hbrush;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=ClassName;
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.hIconSm=NULL; 
	
	RegisterClassEx(&wc);

	TempHandle = CreateWindowEx(WS_EX_DLGMODALFRAME,ClassName, "",Style,0,0,0,0,hParentWindow, 0, hInst, 0);
	ShowWindow(TempHandle,SW_SHOW);

	return TempHandle;
}

// =============================================================================================
// WINDOW CREATION FUNCTIONS
//         .     
//    (      )
// =============================================================================================

HWND MyCreateIndependentWindow(HWND hParentWindow,HINSTANCE hInst,char * ClassName,WNDPROC callback, DWORD Style,COLORREF back_color,char *Title)
{
	WNDCLASSEX wc;
	HWND TempHandle;

	HBRUSH hbrush;
	wc.style=CS_HREDRAW|CS_VREDRAW;;
	wc.lpfnWndProc=callback;
	wc.cbWndExtra=0;
	wc.cbClsExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	hbrush=CreateSolidBrush(back_color);
	wc.hbrBackground=hbrush;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=ClassName;
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.hIconSm=NULL; 
	
	RegisterClassEx(&wc);

	TempHandle = CreateWindowEx(NULL,ClassName, Title,Style,0,0,100,100,hParentWindow, 0, hInst, 0);
	ShowWindow(TempHandle,SW_SHOW);

	return TempHandle;
}

// =============================================================================================
// MESSAGE PROCESSING FUNCTIONS
// H        .      
//            
// 
// =============================================================================================

LRESULT CALLBACK WndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_CREATE:
		
		//      	
		MessagesWnd = MyCreateWindow(hWnd,hInst,"MESSAGES",(WNDPROC) MessagesWndProc,WS_VISIBLE|WS_CHILD,MESSAGES_BACKGROUND_COLOR);
		ChartsWnd= MyCreateWindow(hWnd,hInst,"CHARTS",(WNDPROC) ChartsWndProc,WS_VISIBLE|WS_CHILD,CHARTS_BACKGROUND_COLOR);
		GraphicsWnd=MyCreateWindow(hWnd,hInst,"GRAPHICS",(WNDPROC) GraphicsWndProc,WS_VISIBLE|WS_CHILD,GRAPHICS_BACKGROUND_COLOR);
	break;
	

	case WM_SIZE:	
		//             
		MoveWindow(MessagesWnd, 0, 0,LOWORD(lParam), 100, TRUE);
		MoveWindow(ChartsWnd,LOWORD(lParam)-200,100, 200,HIWORD(lParam)-100 , TRUE);
		MoveWindow(GraphicsWnd, 0,100,LOWORD(lParam)-200, HIWORD(lParam)-100, TRUE);
		
	break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case ID_SIMULATION:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_PROPERTIES),hWnd,(DLGPROC)Parameters);
			if (data.D3DView)
			{
				if (!data.OpenGLInitialized)
				{
					Engine.EnableOpenGL(GraphicsWnd,&dc,&rc);
					Engine.ClearWindow(0.0,0.0,0.0,0.0,1.0);
					Engine.SetCamera(200,200,200);
					Engine.SetLights();
					Engine.SetSceneGlobals();

					Engine.TemplePos[0]=data.x;
					Engine.TemplePos[1]=data.y;
					Engine.TemplePos[2]=data.z;
	
					Engine.mass=data.mass;
					data.OpenGLInitialized=TRUE;
					RECT ClientRect;
					GetClientRect(GraphicsWnd,&ClientRect);
					if (data.D3DView) Engine.WindowResized(ClientRect.right-ClientRect.left,ClientRect.bottom-ClientRect.top);
				}
			}
			else
			{
				if (data.OpenGLInitialized)
				{
					Engine.DisableOpenGL(GraphicsWnd,dc,rc);
					data.OpenGLInitialized=FALSE;
					InvalidateRect(GraphicsWnd,NULL,TRUE);
					UpdateWindow(GraphicsWnd);
				}
			}

		break;
		case ID_RUN:
			EnableMenuItem(GetMenu(MainAppWnd),ID_RUN,MF_GRAYED);
			EnableMenuItem(GetMenu(MainAppWnd),ID_RESET,MF_ENABLED);
			EnableMenuItem(GetMenu(MainAppWnd),ID_SIMULATION,MF_GRAYED);
			if (!data.debug_mode) 
			{
				char buf[100];
				sprintf(buf,"Com%d",data.comno);
				Com.Initialize(buf,9600,8,NOPARITY,ONESTOPBIT);
			}
			Mass.Initialize(0,0,0,data.mass,data.air,0,0,0);
			if (!data.debug_mode) IOThread=CreateThread(NULL,0,IOThreadFunc,NULL,0,NULL);
			
			if (!data.debug_mode) data.IOThreadActive=TRUE;
			data.run=TRUE;
			UpdateMessages(3);
		break;
		case ID_RESET:
			EnableMenuItem(GetMenu(MainAppWnd),ID_RUN,MF_ENABLED);
			EnableMenuItem(GetMenu(MainAppWnd),ID_RESET,MF_GRAYED);
			EnableMenuItem(GetMenu(MainAppWnd),ID_SIMULATION,MF_ENABLED);

			if (!data.debug_mode) TerminateThread(IOThread,0);
			data.run=FALSE;
			data.IOThreadActive=FALSE;
			UpdateMessages(3);
			Mass.Initialize(0,0,0,data.mass,data.air,0,0,0);
			Engine.SpaceShip[0]=Mass.Location.x;
			Engine.SpaceShip[1]=Mass.Location.y;
			Engine.SpaceShip[2]=Mass.Location.z;

			data.Global_Time=0;
			chinc=0;
			InvalidateRect(ChartsWnd,NULL,TRUE);
			UpdateWindow(ChartsWnd);
			UpdateMessages(2);
		break;
		case ID_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,(DLGPROC)About);
		break;
		}
	break;

	case WM_DESTROY:
		PostQuitMessage(0);
	break;

	default:
		return (DefWindowProc(hWnd,uMsg,wParam,lParam));
	}
	return (0L);
}

void UpdateMessages(int Column)
{
	RECT rt;

	if (Column==1)
	{
		rt.left=0;
		rt.top=0;
		rt.right=290;
		rt.bottom=100;
	}
	if (Column==2)
	{
		rt.left=300;
		rt.top=0;
		rt.right=590;
		rt.bottom=100;

	}
	if (Column==3)
	{
		rt.left=590;
		rt.top=0;
		rt.right=900;
		rt.bottom=100;
	}

	InvalidateRect(MessagesWnd,&rt,TRUE);
	UpdateWindow(MessagesWnd);
}

LRESULT CALLBACK MessagesWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	HDC dc;
	PAINTSTRUCT lp;
	HFONT hFont;
	switch (uMsg)
	{

	case WM_CREATE:
	
	break;
	
	case WM_PAINT:
		char buf[100];

		dc=BeginPaint(hWnd,&lp);
			hFont= CreateFont(17,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_DONTCARE,"Arial");
			SelectObject(dc,hFont);
			SetBkColor(dc,MESSAGES_BACKGROUND_COLOR);
			SetTextColor(dc,RGB(255,255,255));
			
			//    
			SetTextColor(dc,RGB(255,255,0));
			sprintf (buf,"%s"," ");
			TextOut(dc,10,10,buf,strlen(buf));
			SetTextColor(dc,RGB(255,255,255));
			sprintf (buf,": %d",data.mass);
			TextOut(dc,10,30,buf,strlen(buf));
			sprintf (buf,"  : %d",data.air);
			TextOut(dc,10,50,buf,strlen(buf));
			sprintf (buf,"  : %d,%d,%d",data.x,data.y,data.z);
			TextOut(dc,10,70,buf,strlen(buf));

			//    
			SetTextColor(dc,RGB(255,255,0));
			sprintf (buf," (: %d)",data.Global_Time);
			TextOut(dc,300,10,buf,strlen(buf));
			SetTextColor(dc,RGB(255,255,255));
			Mass.GetLocationStr(buf);
			TextOut(dc,300,30,buf,strlen(buf));
			Mass.GetForcesStr(buf);
			TextOut(dc,300,50,buf,strlen(buf));

			//    
			SetTextColor(dc,RGB(255,255,0));
			sprintf (buf,"  (%s)",(data.run?"":""));
			TextOut(dc,590,10,buf,strlen(buf));
			SetTextColor(dc,RGB(255,255,255));
			sprintf (buf,": %s",(data.Time_Running?"ON":"OFF"));
			TextOut(dc,590,30,buf,strlen(buf));
			sprintf (buf," /: %s",(data.IOThreadActive?"ON":"OFF"));
			TextOut(dc,590,50,buf,strlen(buf));
			sprintf (buf,"  : %s",(data.IOComPorts?"ON":"OFF"));
			TextOut(dc,590,70,buf,strlen(buf));
			
	
			DeleteObject(hFont);
		EndPaint(hWnd,&lp);
	case WM_COMMAND:
	

	break;
	default:
		return (DefWindowProc(hWnd,uMsg,wParam,lParam));
	}
	return (0L);
}


LRESULT CALLBACK ChartsWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	HDC dc;
	PAINTSTRUCT lp;
	int i;

	switch (uMsg)
	{
	case WM_CREATE:

		axispen=CreatePen(PS_SOLID,1,RGB(0,0,0));
		limitpen=CreatePen(PS_SOLID,1,RGB(255,0,0));
		linepen=CreatePen(PS_SOLID,1,RGB(255,255,255));
	break;

	
	case WM_PAINT:
		dc=BeginPaint(ChartsWnd,&lp);

		//   x
		//--------------------------------------------------------------
		
		// 
		SelectObject(dc,axispen);
		MoveToEx(dc,10,100,NULL);
		LineTo(dc,180,100);
		MoveToEx(dc,10,100,NULL);
		LineTo(dc,10,5);

		// 
		SelectObject(dc,limitpen);
		MoveToEx(dc,10,100-data.x/6.0,NULL);
		LineTo(dc,180,100-data.x/6.0);

		//  
		SelectObject(dc,linepen);

		if (chinc<CHART_SIZE)
			for (i=0;i<chinc-1;i++)
			{
				MoveToEx(dc,10+i,100-xpos[i]/6.0,NULL);
				LineTo(dc,10+i+1,100-xpos[i+1]/6.0);
			}
		else
			for (i=(chinc-CHART_SIZE);i<chinc-1;i++)
			{
				MoveToEx(dc,10+i-(chinc-CHART_SIZE),100-xpos[i%CHART_SIZE]/6.0,NULL);
				LineTo(dc,10+i+1-(chinc-CHART_SIZE),100-xpos[(i+1)%CHART_SIZE]/6.0);

			}

		//   y
		//--------------------------------------------------------------
		
		// 
		SelectObject(dc,axispen);
		MoveToEx(dc,10,200,NULL);
		LineTo(dc,180,200);
		MoveToEx(dc,10,200,NULL);
		LineTo(dc,10,105);

		// 
		SelectObject(dc,limitpen);
		MoveToEx(dc,10,200-data.y/6.0,NULL);
		LineTo(dc,180,200-data.y/6.0);

		//  
		SelectObject(dc,linepen);

		if (chinc<CHART_SIZE)
			for (i=0;i<chinc-1;i++)
			{
				MoveToEx(dc,10+i,200-ypos[i]/6.0,NULL);
				LineTo(dc,10+i+1,200-ypos[i+1]/6.0);
			}
		else
			for (i=(chinc-CHART_SIZE);i<chinc-1;i++)
			{
				MoveToEx(dc,10+i-(chinc-CHART_SIZE),200-ypos[i%CHART_SIZE]/6.0,NULL);
				LineTo(dc,10+i+1-(chinc-CHART_SIZE),200-ypos[(i+1)%CHART_SIZE]/6.0);

			}


		//   z
		//--------------------------------------------------------------
		
		// 
		SelectObject(dc,axispen);
		MoveToEx(dc,10,300,NULL);
		LineTo(dc,180,300);
		MoveToEx(dc,10,300,NULL);
		LineTo(dc,10,205);

		// 
		SelectObject(dc,limitpen);
		MoveToEx(dc,10,300-data.z/6.0,NULL);
		LineTo(dc,180,300-data.z/6.0);

		//  
		SelectObject(dc,linepen);

		if (chinc<CHART_SIZE)
			for (i=0;i<chinc-1;i++)
			{
				MoveToEx(dc,10+i,300-zpos[i]/6.0,NULL);
				LineTo(dc,10+i+1,300-zpos[i+1]/6.0);
			}
		else
			for (i=(chinc-CHART_SIZE);i<chinc-1;i++)
			{
				MoveToEx(dc,10+i-(chinc-CHART_SIZE),300-zpos[i%CHART_SIZE]/6.0,NULL);
				LineTo(dc,10+i+1-(chinc-CHART_SIZE),300-zpos[(i+1)%CHART_SIZE]/6.0);

			}

		SetBkColor(dc,CHARTS_BACKGROUND_COLOR);
		TextOut(dc,2,320,"  ",sizeof("  ")-1);
		TextOut(dc,2,335,"   ",sizeof("   ")-1);
		TextOut(dc,2,350,"(x,y,z).",sizeof("(x,y,z).")-1);

		EndPaint(ChartsWnd,&lp);
	break;


	default:
		return (DefWindowProc(hWnd,uMsg,wParam,lParam));
	}
	return (0L);
}

LRESULT CALLBACK GraphicsWndProc (HWND hWnd,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT lp;
	UINT k;
	HBRUSH red,white;

	if (!data.D3DView)
		if (uMsg==WM_PAINT)
		{
			dc=BeginPaint(hWnd,&lp);
			red=CreateSolidBrush(RGB(255,0,0));
				SelectObject(dc,red);
				Ellipse(dc,data.x-(0.5*data.z)-10,data.y-(0.5*data.z)-10,data.x+(0.5*data.z)+10,data.y+(0.5*data.z)+10);	//    
				white=CreateSolidBrush(RGB(255,255,255));
				SelectObject(dc,white);
				Ellipse(dc,Mass.Location.x-(0.5*Mass.Location.z)-10,Mass.Location.y-(0.5*Mass.Location.z)-10,Mass.Location.x+(0.5*Mass.Location.z)+10,Mass.Location.y+(0.5*Mass.Location.z)+10);	//   
				DeleteObject(white);
				DeleteObject(red);
			EndPaint(hWnd,&lp);
		}


	switch (uMsg)
	{
	case WM_CREATE:
		
		
		k=SetTimer(hWnd,10000,INTERVAL,MyTimer);
		data.Time_Running=TRUE;
		UpdateMessages(3);
	break;
	
	case WM_SIZE:
		RECT ClientRect;
		GetClientRect(hWnd,&ClientRect);
		if (data.D3DView) Engine.WindowResized(ClientRect.right-ClientRect.left,ClientRect.bottom-ClientRect.top);
	break;
	case WM_DESTROY:
		if (data.D3DView) Engine.DisableOpenGL(hWnd,dc,rc); 
		PostQuitMessage(0);
	break;
	
	default:
		return (DefWindowProc(hWnd,uMsg,wParam,lParam));
	
	}
	return (0L);
}



/*********************************************************************************************************/
/*       													 */
/*********************************************************************************************************/

BOOL CALLBACK About (HWND hDlg,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		return TRUE;
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog (hDlg,TRUE);
			return (TRUE);
		}
		break;
	}

	return (FALSE);
}



BOOL ExchangeData(struct APPDATA *d, int direction,char * ErrorMsg,HWND hDlg)
{
	BOOL result;
	char buf[100];
	if (direction==0) //  -> 
	{
		SetDlgItemInt(hDlg,IDC_MASS,d->mass,FALSE);
		SetDlgItemInt(hDlg,IDC_AIR,d->air,TRUE);
		SetDlgItemInt(hDlg,IDC_X,d->x,TRUE);
		SetDlgItemInt(hDlg,IDC_Y,d->y,TRUE);
		SetDlgItemInt(hDlg,IDC_Z,d->z,TRUE);
		SetDlgItemInt(hDlg,IDC_DELAY,d->DELAY,FALSE);
		SetDlgItemInt(hDlg,IDC_COMPORT,d->comno,FALSE);

		sprintf(buf,"%.2f",d->kp);
		SetDlgItemText(hDlg,IDC_KP,buf);

		sprintf(buf,"%.2f",d->kd);
		SetDlgItemText(hDlg,IDC_KD,buf);

		sprintf(buf,"%.2f",d->ki);
		SetDlgItemText(hDlg,IDC_KI,buf);

		sprintf(buf,"%.2f",d->kp2);
		SetDlgItemText(hDlg,IDC_KP2,buf);

		sprintf(buf,"%.2f",d->kd2);
		SetDlgItemText(hDlg,IDC_KD2,buf);

		sprintf(buf,"%.2f",d->ki2);
		SetDlgItemText(hDlg,IDC_KI2,buf);

		sprintf(buf,"%.2f",d->kp3);
		SetDlgItemText(hDlg,IDC_KP3,buf);

		sprintf(buf,"%.2f",d->kd3);
		SetDlgItemText(hDlg,IDC_KD3,buf);

		sprintf(buf,"%.2f",d->ki3);
		SetDlgItemText(hDlg,IDC_KI3,buf);

		if (d->full_screen==TRUE) CheckDlgButton(hDlg,IDC_FSCREEN,BST_CHECKED);
		else CheckDlgButton(hDlg,IDC_FSCREEN,BST_UNCHECKED);
		if (d->debug_mode==TRUE) 
		{
			CheckDlgButton(hDlg,IDC_DEBUG,BST_CHECKED);
			EnableWindow(GetDlgItem(hDlg,IDC_KP),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI),TRUE);

			EnableWindow(GetDlgItem(hDlg,IDC_KP2),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD2),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI2),TRUE);

			EnableWindow(GetDlgItem(hDlg,IDC_KP3),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD3),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI3),TRUE);
		}
		else 
		{
			CheckDlgButton(hDlg,IDC_DEBUG,BST_UNCHECKED);
			EnableWindow(GetDlgItem(hDlg,IDC_KP),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI),FALSE);

			EnableWindow(GetDlgItem(hDlg,IDC_KP2),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD2),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI2),FALSE);

			EnableWindow(GetDlgItem(hDlg,IDC_KP3),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KD3),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_KI3),FALSE);
		}
		if (d->game_mode==TRUE) CheckDlgButton(hDlg,IDC_GAME,BST_CHECKED);
		else CheckDlgButton(hDlg,IDC_GAME,BST_UNCHECKED);

		if (d->D3DView==TRUE) CheckDlgButton(hDlg,IDC_3D,BST_CHECKED);
		else CheckDlgButton(hDlg,IDC_3D,BST_UNCHECKED);
	}

	if (direction==1) //  -> 
	{
		d->mass=GetDlgItemInt(hDlg,IDC_MASS,&result,FALSE);
		if (!result) 
		{
			strcpy(ErrorMsg,"    ");
			return FALSE;
		}
		d->air=GetDlgItemInt(hDlg,IDC_AIR,&result,TRUE);
		if (!result) 
		{
			strcpy(ErrorMsg,"      ");
			return FALSE;
		}
		d->x=GetDlgItemInt(hDlg,IDC_X,&result,TRUE);
		if (!result) 
		{
			strcpy(ErrorMsg,"     x");
			return FALSE;
		}
		d->y=GetDlgItemInt(hDlg,IDC_Y,&result,TRUE);
		if (!result) 
		{
			strcpy(ErrorMsg,"     y");
			return FALSE;
		}
		d->z=GetDlgItemInt(hDlg,IDC_Z,&result,TRUE);
		if (!result) 
		{
			strcpy(ErrorMsg,"     z");
			return FALSE;
		}
		d->DELAY=GetDlgItemInt(hDlg,IDC_DELAY,&result,FALSE);
		if (!result) 
		{
			strcpy(ErrorMsg,"  t  ");
			return FALSE;
		}
		d->comno=GetDlgItemInt(hDlg,IDC_COMPORT,&result,FALSE);
		if (!result) 
		{
			strcpy(ErrorMsg,"     ");
			return FALSE;
		}
		
		// x axis ----------------------------------------------------
		GetDlgItemText(hDlg,IDC_KP,buf,100);
		d->kp=atof(buf);
		if (d->kp==0.0) 
		{
			strcpy(ErrorMsg,"  Kp (x)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KD,buf,100);
		d->kd=atof(buf);
		if (d->kd==0.0) 
		{
			strcpy(ErrorMsg,"  Kd (x)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KI,buf,100);
		d->ki=atof(buf);
		if (d->ki==0.0) 
		{
			strcpy(ErrorMsg,"  Ki (x)  ");
			return FALSE;
		}

		// y axis ----------------------------------------------------
		GetDlgItemText(hDlg,IDC_KP2,buf,100);
		d->kp2=atof(buf);
		if (d->kp2==0.0) 
		{
			strcpy(ErrorMsg,"  Kp (y)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KD2,buf,100);
		d->kd2=atof(buf);
		if (d->kd2==0.0) 
		{
			strcpy(ErrorMsg,"  Kd (y)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KI2,buf,100);
		d->ki2=atof(buf);
		if (d->ki2==0.0) 
		{
			strcpy(ErrorMsg,"  Ki (y)  ");
			return FALSE;
		}

		// z axis ----------------------------------------------------
		GetDlgItemText(hDlg,IDC_KP3,buf,100);
		d->kp3=atof(buf);
		if (d->kp3==0.0) 
		{
			strcpy(ErrorMsg,"  Kp (z)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KD3,buf,100);
		d->kd3=atof(buf);
		if (d->kd3==0.0) 
		{
			strcpy(ErrorMsg,"  Kd (z)  ");
			return FALSE;
		}

		GetDlgItemText(hDlg,IDC_KI3,buf,100);
		d->ki3=atof(buf);
		if (d->ki3==0.0) 
		{
			strcpy(ErrorMsg,"  Ki (z)  ");
			return FALSE;
		}


		if (IsDlgButtonChecked(hDlg,IDC_FSCREEN)==BST_CHECKED) d->full_screen=TRUE;
		else d->full_screen=FALSE;
		if (IsDlgButtonChecked(hDlg,IDC_DEBUG)==BST_CHECKED) d->debug_mode=TRUE;
		else d->debug_mode=FALSE;
		if (IsDlgButtonChecked(hDlg,IDC_GAME)==BST_CHECKED) d->game_mode=TRUE;
		else d->game_mode=FALSE;
		if (IsDlgButtonChecked(hDlg,IDC_3D)==BST_CHECKED) d->D3DView=TRUE;
		else d->D3DView=FALSE;
		
		d->counter=(int) (d->DELAY/(float)INTERVAL);
	}

	return TRUE;
}


BOOL CALLBACK Parameters (HWND hDlg,UINT uMsg,WPARAM wParam, LPARAM lParam)
{
	BOOL result;
	char Message[100];

	switch (uMsg)
	{
	case WM_INITDIALOG:
			ExchangeData(&data,0,Message,hDlg);
		return TRUE;
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_DEBUG)
		{
			data.debug_mode=!data.debug_mode;
			if (data.debug_mode==TRUE)
			{
				EnableWindow(GetDlgItem(hDlg,IDC_KP),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI),TRUE);

				
				EnableWindow(GetDlgItem(hDlg,IDC_KP2),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD2),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI2),TRUE);

				EnableWindow(GetDlgItem(hDlg,IDC_KP3),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD3),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI3),TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlg,IDC_KP),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI),FALSE);
				
				EnableWindow(GetDlgItem(hDlg,IDC_KP2),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD2),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI2),FALSE);

				EnableWindow(GetDlgItem(hDlg,IDC_KP3),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KD3),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_KI3),FALSE);
			}
		}
		if (LOWORD(wParam) == IDOK )
		{
			InvalidateRect(ChartsWnd,NULL,TRUE);
			UpdateWindow(ChartsWnd);
			result=ExchangeData(&data,1,Message,hDlg);
			if (result==FALSE)
				MessageBox(hDlg,Message,"  ",MB_OK|MB_ICONEXCLAMATION);
			else
			{
				UpdateMessages(1);

				Engine.TemplePos[0]=data.x;
				Engine.TemplePos[1]=data.y;
				Engine.TemplePos[2]=data.z;

				Engine.mass=data.mass;

				EndDialog (hDlg,TRUE);
				return (TRUE);
			}
		}
		if (LOWORD(wParam) == IDCANCEL)
		{
			EndDialog (hDlg,TRUE);
			return (TRUE);
		}
		break;
	}

	return (FALSE);
}

VOID CALLBACK MyTimer(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime)
{
	BYTE keys[256];
	PBYTE key_p=keys;
	
	if (data.D3DView)
	{
		GetKeyboardState(key_p);

		if ((key_p[65]&(0x80))==0x80)
			Engine.RollCamera(0,SPEED);
		if ((key_p[68]&(0x80))==0x80)
			Engine.RollCamera(1,SPEED);
		if ((key_p[87]&(0x80))==0x80)
			Engine.RollCamera(2,SPEED);
		if ((key_p[83]&(0x80))==0x80)
			Engine.RollCamera(3,SPEED);


		if ((key_p[VK_UP]&(0x80))==0x80)	
			Engine.MoveCamera(2,SPEED);	
		if ((key_p[VK_DOWN]&(0x80))==0x80)
			Engine.MoveCamera(3,SPEED);
		if ((key_p[VK_LEFT]&(0x80))==0x80)
			Engine.MoveCamera(0,SPEED);
		if ((key_p[VK_RIGHT]&(0x80))==0x80)
			Engine.MoveCamera(1,SPEED);
			

		if ((key_p[32]&(0x80))==0x80)
			Engine.CreateBullet();

		//if ((key_p[13]&(0x80))==0x80)
	
		if (((key_p[49]&(0x80))==0x80)&&((key_p[50]&(0x80))==0x80)&&((key_p[51]&(0x80))==0x80))
			Engine.DrawTemple=!Engine.DrawTemple;
	
	}

	if (data.run==TRUE)
	{
		if (data.debug_mode==TRUE)
			Mass.CalculateForces(data.kp,data.kd,data.ki,data.kp2,data.kd2,data.ki2,data.kp3,data.kd3,data.ki3,data.x,data.y,data.z);

		data.Global_Time++;
		Mass.CalculateNextLocation();

		
		xpos[chinc%CHART_SIZE]=Mass.Location.x;
		ypos[chinc%CHART_SIZE]=Mass.Location.y;
		zpos[chinc%CHART_SIZE]=Mass.Location.z;
		chinc++;
		InvalidateRect(ChartsWnd,NULL,TRUE);
		UpdateWindow(ChartsWnd);
		Engine.SpaceShip[0]=Mass.Location.x;
		Engine.SpaceShip[1]=Mass.Location.y;
		Engine.SpaceShip[2]=Mass.Location.z;
		UpdateMessages(2);	
	}
	
	
	
	if (data.D3DView) 
	{
		Engine.ClearWindow(0,0,0,0.0,1.0);
		Engine.UpdateBullets();
		Engine.DrawObjects();
		Engine.Flip();
	}
	else
	{
		InvalidateRect(GraphicsWnd,NULL,TRUE);
		UpdateWindow(GraphicsWnd);
	}
}

DWORD WINAPI IOThreadFunc(LPVOID params)
{
	BOOL r1,r2,r3;
	short temp1;
	short temp2;
	short temp3;
	
		
	while (1)
	{
		
		Com.WriteShort(Mass.Location.x,TIMEOUT);
		Com.WriteShort(Mass.Location.y,TIMEOUT);
		Com.WriteShort(Mass.Location.z,TIMEOUT);


		data.IOComPorts=TRUE;
		UpdateMessages(3);

		r1=Com.ReadShort(&temp1,TIMEOUT);
		r2=Com.ReadShort(&temp2,TIMEOUT);
		r3=Com.ReadShort(&temp3,TIMEOUT);
		
		data.IOComPorts=FALSE;
		UpdateMessages(3);

		if (r1&&r2&&r3)
		{
			Mass.UpdateForces(temp1,temp2,temp3);	
		}
		
	}

	return 0;
}